using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Petar_Nesic_III_1
{
    class Program
    {
        static bool Moguce(int[] A, int i, int b, int l, int r, bool g)
        {
            bool z = false;
            if (b > 1)
            {
                return false;
            }
            if (l + i > r)
            {
                return true;
            }
            if (g)
            {
                if (A[l + i - 2] > A[l + i])
                {
                    return false;
                }
            }
            else if (A[l + i - 1] > A[l + i])
            {
                b++;
            }
            return Moguce(A, i + 1, b, l, r, z);
        }
        static void Main(string[] args)
        {
            int N = int.Parse(Console.ReadLine());
            string[] s = Console.ReadLine().Split();
            int[] A = new int[200000];
            for (int i = 0; i < N; i++)
            {
                A[i] = int.Parse(s[i]);
            }
            int Q = int.Parse(Console.ReadLine());
            bool[] k = new bool[100000];
            for (int i = 0; i < Q; i++)
            {
                string[] g = Console.ReadLine().Split();
                k[i] = Moguce(A, 1, 0, int.Parse(g[0]) - 1, int.Parse(g[1]) - 1, false);
            }
            for (int i = 0; i < Q; i++)
            {
                if (k[i]) Console.WriteLine("DA");
                else Console.WriteLine("NE");
            }
        }
    }
}